
### Community detection with node features
### Author: Yuan Zhang   yzhanghf@gmail.com
### Input: 1. A: adjacency matrix, n\times n
###        2. K: number of communities
###        3. phi: similarity matrices for individual features, n\times n\times p
###           For example: if features are f_1,\ldots,f_p, 
###           then phi_{ijk} is the similarity between f_k's for nodes i and j
###        4. 

require(Rcpp);
require(RcppArmadillo);
sourceCpp("JCDC.cpp");

## Initialize with spectral clustering

D.inv = diag(1./(sqrt(apply(A, 1, sum))+1e-7));
Laplacian = D.inv %*% A %*% D.inv;
L.svd = svd(Laplacian);
U.K = L.svd$u[, 1:K];
spec.cluster = kmeans(U.K, K, nstart=10)$cluster;
G.fit = array(0, c(N, K));
for(k in 1:K){
	G.fit[spec.cluster==k, k] = 1;
}

## Optimize JCDC
p = dim(phi)[3];	if(length(dim(phi))==2){p = 1;}
# JCDC(A, SimilarityCube, DimensionOfFeatures, InitialCommunityGuess, StepSize, K, NumberOfIterations,
#		NumberOfMaxGradientRounds, NumberOfMaxTabuRounds, W_max, Lambda, RandomStart(0/1), Alpha)
result <- JCDC(A, phi, p, G.fit, 1, K, 20, 30, 20, W_max, 2, 0, 1);
cluster_JCDC = as.vector(result$G.fit %*% (1:K));



